
function [z]=%der_pinv(x)
  pinvx = pinv(x.v);
  [m,n] = size(x.v);
  if m < n then
    if rank(x.v) == m then
      xxt = x.v*x.v';  //'
      dpinvx = xxt\(x.dv-(x.dv*x.v'+x.v*x.dv')'*pinvx'); 
      dpinvx = dpinvx'; //'
    end
  else
    if rank(x.v) == n then
      xtx = x.v'*x.v; //'
      dpinvx = xtx \ (x.dv'-(x.dv'*x.v+x.v'*x.dv)*pinvx); //'
    end
  end
  z = der(pinvx,dpinvx);
endfunction
