
function [z]=%der_det(x)
  detx = det(x.v);
  if abs(detx) < 1e-6 then
    n = size(x.v,1);
    x.v=-x.v'; //'
    d = -trace(x.v);
    b = x.v+d*eye(x.v);
    for k=2:n-1,
      bp = b*x.v;
      d = -trace(bp)/k;
      b = bp+d*eye(x.v);
    end
    z = der(detx,trace(b*x.dv));
  else
    z = der(detx,trace(x.v \ x.dv));
  end
endfunction
